BICO 1.1

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Pages
Public Member Functions | Static Public Member Functions | List of all members
CluE::PartitionProvider< T > Class Template Referenceabstract

Abstract base class to access results of partition based clustering algorithms. More...

`#include <partitionprovider.h>`

Collaboration diagram for CluE::PartitionProvider< T >:

## Public Member Functions
virtual | ~PartitionProvider ()
virtual unsigned int | number_of_solutions () const =0
| returns the number of available solutions More...
virtual unsigned int | size_of_solution (unsigned int index) const =0
| returns the size of a particular solution More...
virtual unsigned int | clustersize (unsigned int solutionIndex, unsigned int partitionIndex) const =0
| Returns the cardinality of the specified cluster from the computed clustering. More...
virtual T * | element (unsigned int solutionIndex, unsigned int partitionIndex, unsigned int elementIndex) const =0
| Returns a pointer to a particular element from the specified cluster and clustering. More...
virtual std::vector< T * > | cluster (unsigned int solutionIndex, unsigned int partitionIndex) const =0
| Returns a vector of pointers to the elements of a particular cluster from the specified clustering. More...
virtual std::vector < std::vector< T * > > | clustering (unsigned int solutionIndex) const =0
| Returns the specified clustering as a vector of vector of pointers to the elements. More...

## Static Public Member Functions
static PartitionProvider< T > * | toPartitionProvider (SolutionProvider *s)
| Does a dynamic cast of the given SolutionProvider to a PartitionProvider. More...

## Detailed Description

### template<typename T>
class CluE::PartitionProvider< T >

Abstract base class to access results of partition based clustering algorithms.

Definition at line 16 of file partitionprovider.h.

## Constructor & Destructor Documentation

template<typename T>

virtual CluE::PartitionProvider< T >::~PartitionProvider | ( |  | ) |
| inline virtual

Definition at line 20 of file partitionprovider.h.

## Member Function Documentation

template<typename T>

virtual unsigned int CluE::PartitionProvider< T >::number_of_solutions | ( |  | ) | const
| pure virtual

returns the number of available solutions

The algorthm may compute more than one solution of possibly different size, where size means number of computed clusters, proxies (e.g. cluster centers) or the size of a coreset. The sizes can be retrieved by a call to size_of_solution().

template<typename T>

virtual unsigned int CluE::PartitionProvider< T >::size_of_solution | ( | unsigned int | index | ) | const
| pure virtual

returns the size of a particular solution

Parameters

  index | number between 0 and number_of_solutions()-1

Returns
  the size for the requested clustering

template<typename T>

virtual unsigned int CluE::PartitionProvider< T >::clustersize | ( | unsigned int | solutionIndex,
|  | unsigned int | partitionIndex
| ) |  | const
| pure virtual

Returns the cardinality of the specified cluster from the computed clustering.

template<typename T>

virtual T* CluE::PartitionProvider< T >::element | ( | unsigned int | solutionIndex,
|  | unsigned int | partitionIndex,
|  | unsigned int | elementIndex
| ) |  | const
| pure virtual

Returns a pointer to a particular element from the specified cluster and clustering.

template<typename T>

virtual std::vector<T*> CluE::PartitionProvider< T >::cluster | ( | unsigned int | solutionIndex,
|  | unsigned int | partitionIndex
| ) |  | const
| pure virtual

Returns a vector of pointers to the elements of a particular cluster from the specified clustering.

template<typename T>

virtual std::vector<std::vector<T*> > CluE::PartitionProvider< T >::clustering | ( | unsigned int | solutionIndex | ) | const
| pure virtual

Returns the specified clustering as a vector of vector of pointers to the elements.

template<typename T>

static PartitionProvider<T>* CluE::PartitionProvider< T >::toPartitionProvider | ( | SolutionProvider * | s | ) |
| inline static

Does a dynamic cast of the given SolutionProvider to a PartitionProvider.

Returns
  NULL if the SolutionProvider is not a PartitionProvider instance

Definition at line 66 of file partitionprovider.h.

The documentation for this class was generated from the following file:

- src/base/partitionprovider.h